# Nginx sample file
# Based on https://docs.gunicorn.org/en/stable/deploy.html

upstream backend {
    # fail_timeout=0 means we always retry an upstream even if it failed
    # to return a good HTTP response

    # for a TCP configuration
    server pokeapi:8000 fail_timeout=0;
}

limit_req_zone $binary_remote_addr zone=app:10m rate=10r/s;

server {
    # if no Host match, close the connection to prevent host spoofing
    listen 80 default_server;
    return 444;
}

server {
    listen 80 deferred;

    # set the correct host(s) for your site
    server_name {{ fqdn }};

    # Don't tell nginx version to clients.
    server_tokens off;

    # Mitigate httpoxy attack
    proxy_set_header Proxy "";

    # Configure proxy
    set_real_ip_from  172.16.241.0/24;
    real_ip_header    X-Forwarded-For;

    charset     utf-8;

    # max upload size
    client_max_body_size 5M;   # adjust to taste

    keepalive_timeout 3;

    # Security headers not set by the app
    add_header Content-Security-Policy "default-src 'self' 'unsafe-inline'; img-src 'self' data:;" always;
    add_header Referrer-Policy "same-origin" always;
 
    ## Disable .htaccess and other hidden files
    location ~ /\.(?!well-known).* {
        return 404;
        access_log off;
        log_not_found off;
    }

    location {% if pka_api_prefix is defined %}{{ pka_api_prefix }}{% endif %}/static/ {
        # checks for static file, if not found proxy to app
        index index.html;
        alias /srv/app/static/;
    }

    location {% if pka_api_prefix is defined %}{{ pka_api_prefix }}{% endif %} {
        try_files $uri @proxy_to_backend;
    }

    location @proxy_to_backend {
        limit_req zone=app burst=12 delay=8;
        limit_req_status 429;
        proxy_set_header X-Forwarded-For $proxy_add_x_forwarded_for;
        proxy_set_header X-Forwarded-Proto https;
        proxy_set_header Host $http_host;
        # we don't want nginx trying to do something clever with
        # redirects, we set the Host: header above already.
        proxy_redirect off;
        proxy_buffering off;
        proxy_pass http://backend;
    }

}
